Subject: Re: bad TSO performance in 2.6.9-rc2-BK

From: "David S. Miller" <[email-masked]>
Date: Wed, 29 Sep 2004 14:00:16 -0700

On Tue, 28 Sep 2004 23:27:21 -0400 (EDT)
John Heffner <[email-masked]> wrote:

> On Wed, 29 Sep 2004, Andi Kleen wrote:
> 
> > I'm afraid I must report it's still not completely solved for me yet.
> > 10s netperf with TSO on with your patches gives now ~10MB/s less than
> > with TSO off (57 vs 67). It's better than before, but not really
> > fixed yet.
> >
> > Looking at my tcpdumps and comparing TSO on/off I see a quite
> > strange effect. It only acks on every ~25th packet with TSO off
> > but every ~16th packet with TSO on.
> >
> > Receiver is a 2.6.5 kernel, it's weird that it violates the
> > ack every two MSS rule.
> 
> Does this help?

I think you hit the jackpot John... or at least you're
on the right trail.

It seems I'll have to do some send buffer liberation when
we partially ACK TSO frames.  Since that isn't happening
currently, this window advancing test never passes until
the full TSO frame is freed up at the sender side.

Patch coming...